from visual import *

oofpez = 9e9
qe=1.6e-19
scalefactor = 2.0e-17

def drawGrid(gridscale,griddim):   #Developed by ZTN 2015
    ##  CONSTANTS
    gridsep = griddim/gridscale
    ##  OBJECTS
    gridarea = box(pos=vector(0,0,0),height=griddim,length=griddim,width=1e-30,color=color.white)
    ## Lines...
    #Vertical
    xl = -griddim/2 + gridsep/2
    while xl < griddim/2:
        cyl = xl
        if cyl < gridsep and cyl > -gridsep:
            cylinder(pos=vector(xl,griddim/2,0),axis=vector(0,-griddim,0),radius=.2e-10,color=color.black)
        else:
            cylinder(pos=vector(xl,griddim/2,0),axis=vector(0,-griddim,0),radius=.2e-10,color=(.7,.7,.7))
        xl = xl + gridsep

    #Horizontal
    xl = -griddim/2 + gridsep/2
    while xl < griddim/2:
            cyl = xl
            if cyl < gridsep and cyl > -gridsep:
                cylinder(pos=vector(-griddim/2,xl,0),axis=vector(griddim,0,0),radius=.2e-10,color=color.black)
            else:
                cylinder(pos=vector(-griddim/2,xl,0),axis=vector(griddim,0,0),radius=.2e-10,color=(.7,.7,.7))
            xl = xl + gridsep





def drawGrid(gridscale,griddim):  #From ZTN Lee College
    ##  CONSTANTS
    gridsep = griddim/gridscale
    ##  OBJECTS
    gridarea = box(pos=vector(0,0,0),height=griddim,length=griddim,width=1e-30,color=color.white)
    ## Lines...
    #Vertical
    xl = -griddim/2 + gridsep/2
    while xl < griddim/2:
        cyl = xl
        if cyl < gridsep and cyl > -gridsep:
            cylinder(pos=vector(xl,griddim/2,0),axis=vector(0,-griddim,0),radius=.2e-10,color=color.black)
        else:
            cylinder(pos=vector(xl,griddim/2,0),axis=vector(0,-griddim,0),radius=.2e-10,color=(.7,.7,.7))
        xl = xl + gridsep

    #Horizontal
    xl = -griddim/2 + gridsep/2
    while xl < griddim/2:
            cyl = xl
            if cyl < gridsep and cyl > -gridsep:
                cylinder(pos=vector(-griddim/2,xl,0),axis=vector(griddim,0,0),radius=.2e-10,color=color.black)
            else:
                cylinder(pos=vector(-griddim/2,xl,0),axis=vector(griddim,0,0),radius=.2e-10,color=(.7,.7,.7))
            xl = xl + gridsep


def drawEFieldVector(position,plus,neg,qplus,qneg):
    Earrow = arrow(pos=position, axis=vector(1e-10,0,0), color=color.orange)
    VLabel = label(pos = Earrow.pos)## write instructions below to tell the computer how to calculate the correct

    r1=Earrow.pos-plus.pos
    rmag1=sqrt(r1.x**2+r1.y**2+r1.z**2)
    rhat1 = (r1/rmag1)
    # 9e-9 * q Rhat / r^2
    E1 = (oofpez * (qplus/rmag1**2) * rhat1)
    Earrow.axis=E1*scalefactor
    #Calculate V1 here

    r2=Earrow.pos-neg.pos
    rmag2=sqrt(r2.x**2+r2.y**2+r2.z**2)
    rhat2 = (r2/rmag2)
    E2 = (oofpez * (qneg/rmag2**2) * rhat2)
    Earrow.axis=E2*scalefactor
    #Calculate V2 here

    Enet = E1 + E2
    Vnet = 0 #Enter calculation here

    Earrow.axis=Enet*scalefactor
    VLabel.text = str(round(Vnet,3))

def drawEField(R,plus,neg,qplus,qneg):
    ## calculations
    theta = 0
    while theta < 2*pi:

        rate(10) # tell computer to go through loop slowly
        drawEFieldVector(R*vector(cos(theta),sin(theta),0),plus,neg,qplus,qneg) #Draw the Efield Vector          
        theta = theta + pi/6

def drawCharges(s):  #This function draws a positive and negative charge seperate by s
    plus = sphere(pos=vector(s/2,0,0), radius=1e-10, color=color.red)
    neg = sphere(pos=vector(-s/2,0,0), radius=1e-10, color=color.blue)
    return plus,neg
